#ifndef __ndk_memory_h__
#define __ndk_memory_h__

#include "multiboot.h"
#include "pmode.h"
#include "pager.h"
#include "stack.h"

#define PAGE_SIZE (4096)

// start allocating at 2GB (linear)
#define ALLOC_OFFSET     (524288)

#define MULTI_PAGE_ENTRY (1)
#define TOP_OF_DMA_STACK (4*1024*1024)

// see ndk/docs/memoryStacks.kwd for more details
typedef struct {
/*
  long  total;
  long  pointer;   // expand up (according to intel)
  long *base;

  struct {
    long  total;
    long  pointer; // expand down (according to intel)
    long *base;
  } used;
*/
  long  total;
  Stack avail;
  Stack used;
} pageStack;

/*
typedef struct {
  long address;
} pageAddr;

typedef struct {
  long address;
  long numPages;
} multiPageAddr;
*/

extern pageStack appStack;  // memory available for apps (and kernel...)
extern pageStack dmaStack;  // memory below 16MB, used for DMA
extern long bssEnd;

void memoryInit(void);
void memoryCreateStacks(void);
long memoryPageUsedByKernel(long page);
void memoryAllocateKernel(void);
void memoryStackSpecs(pageStack *pStack);

void *memoryAllocUnmappedPage(void);
void *memoryAllocPage(void);
void *memoryAllocPages(void);
void *memoryMapPage(void *phyAddr);
void  memoryFreePage(void *linAddr);

#endif
