#ifndef __ndk_tss_h__
#define __ndk_tss_h__

#include "ndk.h"
#include "gdt.h"
#include "idt.h"
#include "pager.h"
#include "array.h"
#include "descgate.h"

#define TASK_FLAG_IOMAP  (1)

#define TASK_TYPE_KERNEL (0)
#define TASK_TYPE_USER   (1)
#define TASK_TYPE DAEMON (2)

#define TASK_EXECUTING   (0)
#define TASK_READY       (1)
#define TSAK_BUSY        (2)
#define TASK_WAITING     (3)

/* TSS definition */
typedef struct {        /* TSS for 386+ */
  long  link,
        esp0,
        ss0,
        esp1,
        ss1,
        esp2,
        ss2,
        cr3,
        eip,
        eflags,
        eax,
        ecx,
        edx,
        ebx,
        esp,
        ebp,
        esi,
        edi,
        es,
        cs,
        ss,
        ds,
        fs,
        gs,
        ldtr;
  short trace,
        io_map_addr;
} TSS __attribute__ ((packed));

typedef struct {        /* TSS for 386+ */
  long  link,
        esp0,
        ss0,
        esp1,
        ss1,
        esp2,
        ss2,
        cr3,
        eip,
        eflags,
        eax,
        ecx,
        edx,
        ebx,
        esp,
        ebp,
        esi,
        edi,
        es,
        cs,
        ss,
        ds,
        fs,
        gs,
        ldtr;
  short trace,
        io_map_addr;
  char  io_map[8192];
} TSSWithIOMap __attribute__ ((packed));

typedef struct {
  long  driverSpecific[4];
  //union {
  //  TSSWithIOMap *withIO;
  //  TSS *withoutIO;
  //} tss;
  long  tss;
  short selector;
  short null;
  long  uid;
  long  gid;
  char  priority;
  char  status;
  char  type;
  char  flags;
  long  startingTick;
  long  totalBusyTicks;
  long  totalWaitTicks;
  long  totalExecTicks;
  long  totalTimesActive;
  long  next;
} Task __attribute__ ((packed));

extern Task *currentTask;
extern Task *firstTask;

#endif
